package com.biganto.visual.roompark.domain.use_case

import com.biganto.visual.roompark.data.data_provider.featuresVariants
import com.biganto.visual.roompark.data.repository.db.requrey.model.EstateEntity
import com.biganto.visual.roompark.domain.contract.AuthContract
import com.biganto.visual.roompark.domain.contract.FlatPlanContract
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 20.04.2020.
 */

class PlanTypesUseCase @Inject constructor(
    private val planContract: FlatPlanContract,
    private val auth:AuthContract
){

    fun fetchNotDownloadedPlansSizes() =
        auth.currentUser()
            .map { user ->
                val list =
                    user.deals?.map { it.estate as EstateEntity }?.toMutableList()
                        ?: mutableListOf()
                list.addAll(user.estates?.map { it as EstateEntity } ?: arrayListOf())
                list
            }
            .flatMapIterable { it }
            .flatMap {
                        planContract.getPlanTypes(it.id)
                            .map { plantypes -> plantypes.flatMap { plan -> plan.featuresVariants }}
            }
            .map { list -> list.sumBy{ if (planContract.getPlanFile(it).exists()) 0 else 1 }}
            .scan { t1: Int, t2: Int ->  t1+t2}
}
